﻿// AriDEV develop this Plugin with passion!
// This Plugin catch Beasts for your Barn!
// https://github.com/AriDEV
using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.IO;
using System.Linq;
using System.Net;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Xml.Linq;

// HB Stuff
using Styx;
using Styx.Helpers;
using Styx.Plugins;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Styx.TreeSharp;

namespace AutoBarnTraper
{
    
    public class AutoBarnTraper : HBPlugin
    {
        #region Globals
        public override string Name { get { return "AutoBarnTraper"; } }
        public override string Author { get { return "AriDEV"; } }
        public override Version Version { get { return new Version(1, 0, 0, 8); } }
        public override string ButtonText { get { return "https://github.com/AriDEV"; } }
        public override bool WantButton { get { return false; } }
        private static LocalPlayer Me { get { return StyxWoW.Me; } }
        #endregion

        public static WoWItem FindFirstUsableItemBySpell(params string[] spellNames)
        {
            List<WoWItem> carried = StyxWoW.Me.CarriedItems;
            // Yes, this is a bit of a hack. But the cost of creating an object each call, is negated by the speed of the Contains from a hash set.
            // So take your optimization bitching elsewhere.
            var spellNameHashes = new HashSet<string>(spellNames);

            return (from i in carried
                    let spells = i.Effects
                    where i.ItemInfo != null && spells != null && spells.Count != 0 &&
                          i.Usable &&
                          i.Cooldown == 0 &&
                          i.ItemInfo.RequiredLevel <= StyxWoW.Me.Level &&
                          spells.Any(s => s.Spell != null && spellNameHashes.Contains(s.Spell.Name))
                    orderby i.ItemInfo.Level descending
                    select i).FirstOrDefault();
        }

        public WoWItem UsableTrapItem()
        {
            return FindFirstUsableItemBySpell("Deadly Iron Trap", "Improved Iron Trap", "Iron Trap"); // Reversed order to use strongest trap if u have 2 difrent traps.
        }

        public override void Pulse()
        {
            if (!Me.Combat || !Me.IsAlive || Me.IsGhost || Me.IsOnTransport || Me.OnTaxi || Me.Stunned || (Me.Mounted && Me.IsFlying)) // Chillax
            {
                return;
            }

            if (Me.Combat && Me.CurrentTarget.HealthPercent <= 55) // Pay Attn!
            {
                ObjectManager.Update();
                //Styx.Common.Logging.Write(System.Windows.Media.Color.FromRgb(255,0,255), "Update ObjectManager!");
                List<WoWUnit> objList = ObjectManager.GetObjectsOfType<WoWUnit>()
                .Where(o => 
                // Add Entries u want to catch // later maybe with settings.
                //*********************************************************
                // Frostfire Ridge
                o.Entry == 72162  || // Wooly Clefthoof
                o.Entry == 76593  || // Frost Wolf Alpha
                o.Entry == 76597  || // Frost Wolf
                o.Entry == 75416  || // Coldsnout Boar
                o.Entry == 79756  || // Coldsnout Sow
                // Nagrand
                o.Entry == 78575  || // Leatherhide Clefthoof
                o.Entry == 81898  || // Leatherhide Bull
                o.Entry == 78459  || // Tenderhoof Meadowstomper
                o.Entry == 78460  || // Meadowstomper
                o.Entry == 78277  || // Breezestrider Colt
                o.Entry == 78278  || // Breezestrider Talbuk
                // Shadowmoon Valley
                o.Entry == 74169  || // Gloomshade Howler
                o.Entry == 78385  || // Pearltusk Grazer
                o.Entry == 82452  || // Ancient Pearltusk
                o.Entry == 78276  || // Silverpelt Charger
                o.Entry == 78275  || // Silverpelt Doe
                o.Entry == 87698  || // Rockhide Bull
                o.Entry == 87700  || // Rockhide Grazer
                o.Entry == 82308  || // Shadowmoon Stalker 

				//Arak
				o.Entry == 88589 	//Pridelands Goretusk
                //*********************************************************
                )
                .OrderBy(o => o.Distance).ToList();
                
                foreach (WoWUnit o in objList)
                {
                    if (o.IsWithinMeleeRange)
                    {
                        if (!o.IsDead && !o.IsPet)
                        {
                            WoWItem TrapItem = UsableTrapItem();
                            if (TrapItem != null && TrapItem.Cooldown == 0)
                            {
                                TrapItem.UseContainerItem();
                                Styx.Common.Logging.Write(System.Windows.Media.Color.FromRgb(255,0,255), "AutoBarnTraper: " + TrapItem.Name + "thrown at" + o.Name + "!");
                            }
                        }
                    }
                }
            }
        }
    }
}
    